'***************** (c) 2007 BTC Korporacja ***********************************
'                     http://www kamami.com
'PROJECT  : ADC
'BOARD    : ZL10AVR v.3 (with ATmega32 in socket U2)
'COMPILER : BASCOM AVR
'
'******************************************************************************
'
'    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
'    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
'    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
'    FROM USE OF THIS SOFTWARE.
'
'******************************************************************************
'
'DESCRIPTION :
'    Example of AD conversion. Result of 10 bit conversion is displayed on LCD
'    display (HD44780 compatible).
'
'    Jumpers settings on ZL10AVR:
'        JP11 - 2-3 (=OFF) <- U1 GRES  (general reset)
'        JP9  - 2-3 (=OFF) <- U1 CRYST (crystal)
'        JP10 - 2-3 (=OFF) <- U1 CRYST (crystal)
'        JP5  - 2-3 (=OFF) <- U4 CRYST (crystal)
'        JP6  - 2-3 (=OFF) <- U4 CRYST (crystal)
'        JP7  - 2-3 (=OFF) <- U4 GRES  (general reset)
'        JP2  - 2-3 (=OFF) <- U5 CRYST (crystal)
'        JP3  - 2-3 (=OFF) <- U5 CRYST (crystal)
'        JP4  - 2-3 (=OFF) <- U5 GRES  (general reset)
'        JP1  - 2-3 (=OFF) <- U7 GRES  (general reset)
'        JP21 - 2-3 (=U2/3/5/6) <- active socket (ATmega32 in U2 socket)
'
'        JP24 - 1-2 (=PA0) <- ADC channel 0 on PA0 (in ATmega32)
'        JP25 - 2-3 (=OFF) <- to connect potentiometer R8 to ADC
'                             error on top overlay (OFF means ON)
'
'    LCD connection
'        LCD - IO Line
'        DB4 - PD.4
'        DB5 - PD.5
'        DB6 - PD.6
'        DB7 - PD.7
'        E   - PB.2
'        RS  - PB.0
'
'******************************************************************************

$regfile = "m32def.dat"
$crystal = 8000000                                          '8 MHz - turn on external resonator (fuse bits)
$baud = 1200
$hwstack = 64
$swstack = 64
$framesize = 64

Dim Vadc As Word

Config Portb = Output
Config Portd = Output

Config Lcd = 16 * 2
Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portb.2 , Rs = Portb.0

Config Adc = Single , Prescaler = Auto , Reference = Internal

Start Adc

Initlcd : Cls : Cursor Off
Lcd "  ZL10AVR v.3"
Lowerline
Lcd "ADC Demo"
Waitms 500
Cls

Do
  Waitms 100
  Cls
  Vadc = Getadc(0)
  Lcd "ADC value " ; Vadc
Loop

End