'***************** (c) 2007 BTC Korporacja ***********************************
'                     http://www kamami.com
'PROJECT  : BUZZER
'BOARD    : ZL10AVR v.3 (with ATmega32 in socket U2)
'COMPILER : BASCOM AVR
'
'******************************************************************************
'
'    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
'    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
'    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
'    FROM USE OF THIS SOFTWARE.
'
'******************************************************************************
'
'DESCRIPTION :
'    Simple demonstration of generating sound.
'
'    Jumpers settings on ZL10AVR:
'        JP11 - 2-3 (=OFF) <- U1 GRES  (general reset)
'        JP9  - 2-3 (=OFF) <- U1 CRYST (crystal)
'        JP10 - 2-3 (=OFF) <- U1 CRYST (crystal)
'        JP5  - 2-3 (=OFF) <- U4 CRYST (crystal)
'        JP6  - 2-3 (=OFF) <- U4 CRYST (crystal)
'        JP7  - 2-3 (=OFF) <- U4 GRES  (general reset)
'        JP2  - 2-3 (=OFF) <- U5 CRYST (crystal)
'        JP3  - 2-3 (=OFF) <- U5 CRYST (crystal)
'        JP4  - 2-3 (=OFF) <- U5 GRES  (general reset)
'        JP1  - 2-3 (=OFF) <- U7 GRES  (general reset)
'        JP21 - 2-3 (=U2/3/5/6) <- active socket (ATmega32 in U2 socket)
'
'
'        JP23 - 1-2 (=ON)  <- buzzer connected to PB0
'
'******************************************************************************

$regfile = "m32def.dat"
$crystal = 8000000                                          '8 MHz - turn on external resonator (fuse bits)
$baud = 1200
$hwstack = 64
$swstack = 64
$framesize = 64

Config Portb = Output

Do
  Sound Portb.0 , 1000 , 100
  Waitms 2000
Loop

End