'***************** (c) 2007 BTC Korporacja ***********************************
'                     http://www kamami.com
'PROJECT  : KBD_4x4
'BOARD    : ZL10AVR v.3 (with ATmega32 in socket U2)
'COMPILER : BASCOM AVR
'
'******************************************************************************
'
'    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
'    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
'    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
'    FROM USE OF THIS SOFTWARE.
'
'******************************************************************************
'
'DESCRIPTION :
'    Pressing any button is shown on LCD.
'
'    Jumpers settings on ZL10AVR:
'        JP11 - 2-3 (=OFF) <- U1 GRES  (general reset)
'        JP9  - 2-3 (=OFF) <- U1 CRYST (crystal)
'        JP10 - 2-3 (=OFF) <- U1 CRYST (crystal)
'        JP5  - 2-3 (=OFF) <- U4 CRYST (crystal)
'        JP6  - 2-3 (=OFF) <- U4 CRYST (crystal)
'        JP7  - 2-3 (=OFF) <- U4 GRES  (general reset)
'        JP2  - 2-3 (=OFF) <- U5 CRYST (crystal)
'        JP3  - 2-3 (=OFF) <- U5 CRYST (crystal)
'        JP4  - 2-3 (=OFF) <- U5 GRES  (general reset)
'        JP1  - 2-3 (=OFF) <- U7 GRES  (general reset)
'        JP21 - 2-3 (=U2/3/5/6) <- active socket (ATmega32 in U2 socket)
'        JP26 - 2-3 (=4x4)
'
'    Keyborad connection (you can use CAB_A cables)
'        Zl5 (Keyb) - Zl1 (IO Line)
'        KBD ROW 0 - PA7
'        KBD ROW 1 - PA6
'        KBD ROW 2 - PA5
'        KBD ROW 3 - PA4
'        KBD COL 0 - PA3
'        KBD COL 1 - PA2
'        KBD COL 2 - PA1
'        KBD COL 3 - PA0
'
'******************************************************************************

$regfile = "m32def.dat"
$crystal = 8000000                                          '8 MHz - turn on external resonator (fuse bits)
$baud = 1200
$hwstack = 64
$swstack = 64
$framesize = 64


Config Portb = Output
Config Portd = Output

Config Lcd = 16 * 2
Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portb.2 , Rs = Portb.0

Col0 Alias Porta.3
Col1 Alias Porta.2
Col2 Alias Porta.1
Col3 Alias Porta.0
Row0 Alias Pina.7
Row1 Alias Pina.6
Row2 Alias Pina.5
Row3 Alias Pina.4
Config Row0 = Input
Config Row1 = Input
Config Row2 = Input
Config Row3 = Input
' turn on pull-up resistors
Set Porta.7
Set Porta.6
Set Porta.5
Set Porta.4
Config Col0 = Output
Config Col1 = Output
Config Col2 = Output
Config Col3 = Output

Initlcd : Cls : Cursor Off

Do
  Cls
  Lcd "Press S3..18"
  Lowerline

  Reset Col0 : Set Col1 : Set Col2 : Set Col3
  If Row0 = 0 Then
    Lcd "S12 (C0R0)"
  End If
  If Row1 = 0 Then
    Lcd "S11 (C0R1)"
  End If
  If Row2 = 0 Then
    Lcd "S4 (C0R2)"
  End If
  If Row3 = 0 Then
    Lcd "S3 (C0R3)"
  End If


  Set Col0 : Reset Col1 : Set Col2 : Set Col3
  If Row0 = 0 Then
    Lcd "S14 (C1R0)"
  End If
  If Row1 = 0 Then
    Lcd "S13 (C1R1)"
  End If
  If Row2 = 0 Then
    Lcd "S6 (C1R2)"
  End If
  If Row3 = 0 Then
    Lcd "S5 (C1R3)"
  End If


  Set Col0 : Set Col1 : Reset Col2 : Set Col3
  If Row0 = 0 Then
    Lcd "S16 (C2R0)"
  End If
  If Row1 = 0 Then
    Lcd "S15 (C2R1)"
  End If
  If Row2 = 0 Then
    Lcd "S8 (C2R2)"
  End If
  If Row3 = 0 Then
    Lcd "S7 (C2R3)"
  End If


  Set Col0 : Set Col1 : Set Col2 : Reset Col3
  If Row0 = 0 Then
    Lcd "S18 (C3R0)"
  End If
  If Row1 = 0 Then
    Lcd "S17 (C3R1)"
  End If
  If Row2 = 0 Then
    Lcd "S10 (C3R2)"
  End If
  If Row3 = 0 Then
    Lcd "S9 (C3R3)"
  End If
  Waitms 100

Loop

End