'***************** (c) 2007 BTC Korporacja ***********************************
'                     http://www kamami.com
'PROJECT  : LED_4x4_2
'BOARD    : ZL10AVR v.3 (with ATmega32 in socket U2)
'COMPILER : BASCOM AVR
'
'******************************************************************************
'
'    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
'    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
'    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
'    FROM USE OF THIS SOFTWARE.
'
'******************************************************************************
'
'DESCRIPTION :
'    Simple LEDs demonstration.
'
'    Jumpers settings on ZL10AVR:
'        JP11 - 2-3 (=OFF) <- U1 GRES  (general reset)
'        JP9  - 2-3 (=OFF) <- U1 CRYST (crystal)
'        JP10 - 2-3 (=OFF) <- U1 CRYST (crystal)
'        JP5  - 2-3 (=OFF) <- U4 CRYST (crystal)
'        JP6  - 2-3 (=OFF) <- U4 CRYST (crystal)
'        JP7  - 2-3 (=OFF) <- U4 GRES  (general reset)
'        JP2  - 2-3 (=OFF) <- U5 CRYST (crystal)
'        JP3  - 2-3 (=OFF) <- U5 CRYST (crystal)
'        JP4  - 2-3 (=OFF) <- U5 GRES  (general reset)
'        JP1  - 2-3 (=OFF) <- U7 GRES  (general reset)
'        JP21 - 2-3 (=U2/3/5/6) <- active socket (ATmega32 in U2 socket)
'
'    Matrix display (LED) connection (you can use CAB_A cables)
'        Zl6 (LED) - Zl1 (IO Line)
'        LED ROW 0 - PA0
'        LED ROW 1 - PA1
'        LED ROW 2 - PA2
'        LED ROW 3 - PA3
'        LED COL 0 - PA4
'        LED COL 1 - PA5
'        LED COL 2 - PA6
'        LED COL 3 - PA7
'
'******************************************************************************

$regfile = "m32def.dat"
$crystal = 8000000                                          '8 MHz - turn on external resonator (fuse bits)
$baud = 1200
$hwstack = 64
$swstack = 64
$framesize = 64

' matrix display connection
Config Porta = Output
Led_row0 Alias Porta.0
Led_row1 Alias Porta.1
Led_row2 Alias Porta.2
Led_row3 Alias Porta.3
Led_col0 Alias Porta.4
Led_col1 Alias Porta.5
Led_col2 Alias Porta.6
Led_col3 Alias Porta.7

' RESET Led_col and SET Led_row to turn on LED

' to turn on LED D31 (0,0), RESET col0 and SET row0:
Reset Led_col0 : Set Led_col1 : Set Led_col2 : Set Led_col3
Set Led_row0 : Reset Led_row1 : Reset Led_row2 : Reset Led_row3


Do
Loop

End